function PrioridadeSeparacaoOLController(ScreenService, templateManager,RestEngine, General, maskEngine, ZhFilterPreferences, Utilities) {

    this.setStripeValues = function(widget) {
        
        var filterRow = widget.appliedFilter.FILTER_ROW;
        var stripe = templateManager.container.getWidget('stripe');
       
        stripe.getField('labelStripeUnidade').label ="Operador Logístico: " + filterRow.CDFILIAL + ' - ' + filterRow.NMFILIAL;
    };
    
    this.verificaProjectCorp = function(widget){
        if(window.projectCorp){
            widget.getField("NMFILIAL").filterProperties.readOnly = false;
        } else{
            widget.getField("NMFILIAL").filterProperties.readOnly = true;
        }
    };
    
    this.onEnter = function (widget) {
        var filterRow = {};
        this.verificaProjectCorp(widget);
	    filterRow.NRORG    = getLocalVar('NRORG');
        Utilities.startFilter(templateManager.container.getActiveWidget(), filterRow);
    };
    
    this.dataSourceFilterProduto = function(widget){
        var widgetListUnidade = widget.container.getWidget('listFiliais');
        var gridPrioridade = widget.container.getWidget('gridPrioridade');
        if (gridPrioridade.appliedFilter){
            gridPrioridade._filterInfo[0].label = 'OL';
            widgetListUnidade.dataSourceFilter = [
                {
                    "name": "P_CDFILIOPELOG",
                    "operator": "=",
                    "value": gridPrioridade.appliedFilter.FILTER_ROW.CDFILIAL
                }
            ];
            gridPrioridade.dataSourceFilter = [
                {
                    "name": "P_CDFILIOPELOG",
                    "operator": "=",
                    "value": gridPrioridade.appliedFilter.FILTER_ROW.CDFILIAL
                }
            ];
            enterDashBoard(widget);
        }
    };
    
    this.moveSelectedRowsToGridPrioridade = function(widget){
        moveRowsToGridPrioridade(widget, widget.container.getWidget('listFiliais').dataSource.getCheckedRows());
    };
    
    this.moveAllRegistersToRight = function(widget){
        moveRowsToGridPrioridade(widget, widget.container.getWidget('listFiliais').dataSource.data);   
    };
    
    var moveRowsToGridPrioridade = function(widget, dataset){
        var tamanho = widget.container.getWidget('gridPrioridade').dataSource.data.length;
        var nrPrioridade = 1;
        if(tamanho > 0){
            nrPrioridade = widget.container.getWidget('gridPrioridade').dataSource.data[tamanho-1].NRPRIORIDADE+1;
        }
        dataset.forEach(function(unidade){
            unidade.NRPRIORIDADE = nrPrioridade;
            nrPrioridade = nrPrioridade+1;
        });
        General.callRestEngine('opl_autoforne#/prioridadeOLController/moveSelectedRowsToPrioridade','DataSet',dataset).then(function(calback) {
            enterDashBoard(widget);
        });
    };
    
    this.upRegisterOnPrioridade = function(widget){
        if(widget.dataSource.getCheckedRows().length == 1){
            var index = widget.dataSource.data.indexOf(widget.dataSource.getCheckedRows()[0]);
            var nrPrioridade = widget.dataSource.data[index-1].NRPRIORIDADE;
            
            widget.dataSource.data[index-1].NRPRIORIDADE = widget.dataSource.getCheckedRows()[0].NRPRIORIDADE;
            widget.dataSource.getCheckedRows()[0].NRPRIORIDADE = nrPrioridade;
            General.callRestEngine('opl_autoforne#/prioridadeOLController/updateRegisterOnPrioridade','DataSet',widget.dataSource.data).then(function(calback) {
                enterDashBoard(widget);
            });
        }
    };
    
    this.upFirstRegisterOnPrioridade = function(widget){
        if(widget.dataSource.getCheckedRows().length == 1){
            var index = widget.dataSource.data.indexOf(widget.dataSource.getCheckedRows()[0]);
            widget.dataSource.getCheckedRows()[0].NRPRIORIDADE = widget.dataSource.data[0].NRPRIORIDADE;
            for(var i = 0; i < index; i++) {
                widget.dataSource.data[i].NRPRIORIDADE = widget.dataSource.data[i].NRPRIORIDADE+1;
            }
            General.callRestEngine('opl_autoforne#/prioridadeOLController/updateRegisterOnPrioridade','DataSet',widget.dataSource.data).then(function(calback) {
                enterDashBoard(widget);
            });
        }
    };
    
    this.dowLastRegisterOnPrioridade = function(widget){
        if(widget.dataSource.getCheckedRows().length == 1){
            var index = widget.dataSource.data.indexOf(widget.dataSource.getCheckedRows()[0]);
            var maior = widget.dataSource.data.length;
            widget.dataSource.getCheckedRows()[0].NRPRIORIDADE = widget.dataSource.data[maior-1].NRPRIORIDADE;
            for(var i = maior-1; i > index; i--) {
                widget.dataSource.data[i].NRPRIORIDADE = widget.dataSource.data[i].NRPRIORIDADE-1;
            }
            General.callRestEngine('opl_autoforne#/prioridadeOLController/updateRegisterOnPrioridade','DataSet',widget.dataSource.data).then(function(calback) {
                enterDashBoard(widget);
            });
        }
    };
    
    this.dowRegisterOnPrioridade = function(widget){
        if(widget.dataSource.getCheckedRows().length == 1){
            var index = widget.dataSource.data.indexOf(widget.dataSource.getCheckedRows()[0]);
            var nrPrioridade = widget.dataSource.data[index+1].NRPRIORIDADE;
            
            widget.dataSource.data[index+1].NRPRIORIDADE = widget.dataSource.getCheckedRows()[0].NRPRIORIDADE;
            widget.dataSource.getCheckedRows()[0].NRPRIORIDADE = nrPrioridade;
            General.callRestEngine('opl_autoforne#/prioridadeOLController/updateRegisterOnPrioridade','DataSet',widget.dataSource.data).then(function(calback) {
                enterDashBoard(widget);
            });
        }
    };
    
    var enterDashBoard = function(widget){
        var widgetListUnidade = widget.container.getWidget('listFiliais');
        var gridPrioridade = widget.container.getWidget('gridPrioridade');
        
    	widgetListUnidade.dataSource.clearCheckedRows();
		widgetListUnidade.refreshData = false;
		widgetListUnidade.reload();

		gridPrioridade.dataSource.clearCheckedRows();
		gridPrioridade.refreshData = false;
		gridPrioridade.reload();	
		gridPrioridade.activate();
    };
    
    this.activateActionMoveAllRows = function(widget){
        var widgetListUnidade = widget.container.getWidget('listFiliais');
        var gridPrioridade = widget.container.getWidget('gridPrioridade');
        var dashboardPrioridade = widget.container.getWidget('dashboardPrioridade');
        dashboardPrioridade.getAction('moveAllToRight_always').isVisible = widgetListUnidade.dataSource.data.length > 0;
		gridPrioridade.getAction('moveAllToRight_list').isVisible = widgetListUnidade.dataSource.data.length > 0;     
    };
    
    this.activateWidgetOnSelectRow = function(widget){
		widget.activate();
	};
	
	this.unselectAllRows = function(widgetName){
		var widget = templateManager.container.getWidget(widgetName);
		
		widget.dataSource.clearCheckedRows();
	};
	
	this.activateWidgetOnUnselectAll = function(widget){
		if(widget.dataSource.getCheckedRows().length == 0){
			widget.activate();
		}
	};
	
	this.activateWidgetOnUnselectAll = function(widget, widgetTargetName){
		var widgetTarget = templateManager.container.getWidget(widgetTargetName);
		if(widget.dataSource.getCheckedRows().length == 0){
			widgetTarget.activate();
		}
	};
	
	this.changeMoveButtonsVisibility = function(widget){
		var dataSource = widget.dataSource;
		widget.activate();
		if(dataSource.getCheckedRows().length>1){
			
			widget.getAction('moveUp').isVisible = false;
			widget.getAction('moveUpAll').isVisible = false;
			widget.getAction('moveDown').isVisible = false;
			widget.getAction('moveDownAll').isVisible = false;
		} else {
			var index = dataSource.data.indexOf(dataSource.getCheckedRows()[0]);
			
			widget.getAction('moveUp').isVisible = index == 0 ? false : true;
			widget.getAction('moveUpAll').isVisible = index == 0 ? false : true;
			widget.getAction('moveDown').isVisible = index == dataSource.data.length-1 ? false : true;
			widget.getAction('moveDownAll').isVisible = index == dataSource.data.length-1 ? false : true;
		}
	}; 
	
	this.excluirPrioridade = function (gridPrioridade) {
		General.deleteCrudCheckedRows(gridPrioridade).then(function () {
			gridPrioridade.dataSource.save().then(function () {
				enterDashBoard(gridPrioridade.parent);
			});
		});
	};

}
Configuration(function (ContextRegister) {
	ContextRegister.register('PrioridadeSeparacaoOLController', PrioridadeSeparacaoOLController);
});